--[[
	BASS AMPLIFIER
	THIS IS WHERE ALL THE EXTRA / MAIN FUNCTIONS GO IN
--]]

function bass.getName(target, color)
	if not color then color = colors["light grey"] end
	return color.."<"..player(target, "name")..">"
end

function bass.cloak(target, id, call, ignore)
	if not target or type(target) ~= "number" or not player(target, "exists") then
		target = target or "nil"
		if id and call then bass.info(id, call, colors.red.."Target ID#"..target.." doesn't exists!") end
		return false
	end

	if call and not ignore then
		if user[id].cSilence < 1 then
			user[id].cloak = colors.grey..player(id,"name")..colors.green.." used "..deck.commands.preffix..call.." on "..colors.grey..player(target, "name")
		elseif extra.mod_log then print("bass (( moderation log: "..player(id,"name").." used "..deck.commands.preffix..call.." on "..player(target, "name")) end
	end
	return true
end

function bass.save(id)
	local USGN = player(id,"usgn")
	if USGN > 0 and user[id].rank ~= 0 and not user[id].oclaim then
		local file = io.open("sys/lua/users/"..USGN..".txt","w")

		file:write("rank="..user[id].rank.."\n")
		file:write("cHidden="..user[id].cHidden.."\n")
		file:write("cSilence="..user[id].cSilence.."\n")
		file:write("tag="..user[id].tag.."\n")
		file:write("color="..user[id].color.."\n")

		if extra.chat_colorful then
			file:write("color2="..user[id].color2.."\n")
			file:write("colorMode="..user[id].colorMode.."\n")
		end

		file:close()
	else local file = io.open("sys/lua/users/"..USGN..".txt", "r") if file then file:close() os.remove("sys/lua/users/"..USGN..".txt") end end
end

function bass.info(id, call, msg)
	msg2(id, colors.grey..deck.commands.preffix..call..": "..msg)
end

function bass.colorize(value)
	value = tonumber(value) or 0
	return string.format("%03d", math.max(math.min(value, 255), 0))
end

function bass.muteCore(id)
	id = tonumber(id)

	if type(user[id].cMuted) == "boolean" then freetimer("bass.muteCore", id) else user[id].cMuted = user[id].cMuted - 1 end

	if user[id].cMuted <= 0 then
		freetimer("bass.muteCore", id)
		user[id].cMuted = false
		msg2(id, colors.green.."You are now unmuted!")
	end
end

function bass.closeEvent(background)
	if background == "null" then
		freeimage(bass.eventBackground)
		bass.eventBackground = false
		if extra.server_promote then extra.show_svname() else parse("hudtxt "..extra.server_promote_hud.." \"\" 0 0 1") end

	else
		tween_alpha(background, 600, 0)
		tween_scale(background, 600, bass.eventBackgroundWidth, 0)
		timer(650, "bass.closeEvent", "null")
	end
end

function bass.rgbToHSL(color)
	local tonumber = tonumber

	local R = tonumber(color:sub(1,3)) / 255
	local G = tonumber(color:sub(4,6)) / 255
	local B = tonumber(color:sub(7,9)) / 255
	
	local max, min = math.max(R, G, B), math.min(R, G, B)
	local H, S, L
	
	L = (max + min) * 0.5

	if max == min then H, S = 0, 0 else
		local D = max - min
		local S

	if L > 0.5 then S = D / (2 - max - min) else S = D / (max + min) end
	
		if max == R then
			H = (G - B) / D
			if G < B then H = H + 6 end
		elseif max == G then H = (B - R) / D + 2
		elseif max == B then H = (R - G) / D + 4 end
	
		H = H / 6
	end
	
	return H, S, L
end

timer(10, "bass.setup")
function bass.setup()
	for item, content in pairs(_G) do
		if item ~= "bass" and type(content) == "table" and content.ABOUT and content.ABOUT.commands then
			local about = content.ABOUT
			for id, data in ipairs(about.commands) do table.insert(deck.commands, data) end
			print(colors.green.."bass (( "..about.author.."'s "..about.name.." v"..about.version.." FX successfully loaded!")
		end
	end

	print(colors.green.."bass (( Ready to use!")

	bass.setup = nil
end
