--[[
	BASS SPEAKERS
	THIS IS WHERE THE FUNCTIONS THAT ARE GOING TO BE PERFORMED BY THE COMMANDS GO IN
--]]

extra = {
	-- Values
	prio = 99999;						-- Core hook priority over others. (Don't change unless you know what you're doing)

	-- Eye-candy effects and stuff		-- Visual and server vanity details that do not affect the server administration and may reduce the overall script footprint if removed
	menu_help = true;					-- Enable / Disable the use of menus for the !help/!cmds command
	
	server_promote = false;				-- Enable / Disable the server name promoting HUDTXT at the top of players screen
	server_promote_hud = 0;				-- the ID of the promoting HUDTXT (Try to change this from 0 to 49 if there's missing HUDs when bass is used)

	chat_glow = true;					-- Enable / Disable the glow effect when a STAFF member speaks
	chat_colorful = true;				-- Enable / Disable the advanced chat color customization

	-- Oclaim System					-- System to allow the server administrator to control the server without an USGN // Similar to Rcon
	oclaim_sys = true;					-- Enable / Disable the system
	oclaim_max = 3;						-- Maximum number of failed oclaim attempts
	oclaim_period = 15;					-- Ban duration once the user reaches the maximum number of failed oclaim attempts (in minutes)

	-- Ban System						-- System that makes the specified rank level be able to temp. ban (and not permanently)
	tempban_sys = true;					-- Enable / Disable the system
	tempban_rank = 2; 					-- Rank level that will be under the control of this system
	tempban_max = 7;					-- Maximum ban time for the rank (in minutes)
	
	-- Whois Command					-- Command for identifying players USGN name (only supported on linux currently) // WARNING, THIS COMMAND MAY HALT THE SERVER FOR FEW MS WHEN USED
	whois_enable = false;				-- Enable / Disable this command
	whois_command = "curl";				-- Linux CLI command used to query the page that gives the USGN name to the script (curl or wget -q -O-)
	whois_core_delay = 1444;			-- Delay for retrieving USGN name file after query (increase this if the command is not properly working) (don't set it too low (< 500) neither too high (> 10000))
	
	-- Extra features					-- Extra simple features to reduce the need of other scripts
	show_damage = false;				-- Show player's lost health on hits
	insta_reload = false;				-- Instant weapon reloading

	-- Logging
	msg_log = true; 					-- MSG2 logging (useful for analyzing private messages and debugging)
	mod_log = true;						-- Server moderating logging (logs bans, kicks and other administration related informations)
}

-- Eye-candy effects and stuff
if extra.menu_help then
	addhook("menu", "bass.MENUES")
	function bass.MENUES(id, title, button) if title:sub(1, 8) == "Commands" then bass.list(id, title, button) end end
	
	function bass.list(id, title, button)
		local available = {}
		local list = deck.commands

		for _, command in ipairs(list) do if user[id].rank >= command.level then table.insert(available, command) end end

		local page = tonumber(string.match(title, "(%d*)/"))
		if button == 8 then bass.commands(id, page + 1) end
		if button == 9 then bass.commands(id, page - 1) end
		if button <= 6 and button > 0 then
			local command = available[((page - 1) * 6) + button]
			msg2(id, colors.green.."Command: "..colors.grey..list.preffix..command[1]..colors.green)
			msg2(id, colors.green.."Description: "..command.desc)
			if command.syntax then msg2(id,colors.green.."Usage: "..list.preffix..command.syntax) end
			if command.extra then msg2(id,colors.grey.."Extra: "..command.extra) end
		end
	end
end

if extra.server_promote then
	timer(1000, "extra.update_svname", "", 0)
	function extra.update_svname() parse("hudtxtcolorfade 0 "..extra.server_promote_hud.." 999 "..math.random(0,255).." "..math.random(0,255).." "..math.random(0,255)) end
	function extra.show_svname(id)
		if id then
			id = tonumber(id)
			parse("hudtxt2 "..id.." "..extra.server_promote_hud.." \"\169255128000 "..game("sv_name").."\" "..(player(id, "screenw") * 0.5).." 25 1")
		else for _, id in pairs(player(0, "table")) do extra.show_svname(id) end end
	end
end

if extra.chat_colorful then
	timer(5, "extra.colorfulchat_install")
	function extra.colorfulchat_install()
		local pos = #deck.commands
		for command = 1, #deck.commands do if deck.commands[command][1] == "setcolor" then pos = command break end end
		table.insert(deck.commands, pos + 1, {"setcolormode", level = 1, func = "extra.setcolorMode", desc = "Set chat color mode.", syntax = "setcolormode <color mode value>", extra = "Avalable modes are 0 - normal, 1 - tag, 2 - fade, 3 - random"})
		table.insert(deck.commands, pos + 2, {"setcolor2", level = 1, concat = 1, func = "extra.setcolor2", desc = "Set alternative chat color.", syntax = "setcolor2 <color name or RGB value>", extra = "If you want to use RGB value, separate it using spaces, (example !setcolor2 255 0 25)"})
	
		extra.colorfulchat_install = nil
	end
	
	function extra.setcolor2(id, color)
		user[id].undo = {{"extra.setcolor2", id, user[id].color2:sub(1,3).." "..user[id].color2:sub(4,6).." "..user[id].color2:sub(7,9)}}

		if string.find(color, "%d") then
			local R, G, B = string.match(color, "(%d*) (%d*) (%d*)")
			if R and G and B then
				R, G, B = bass.colorize(R), bass.colorize(G), bass.colorize(B)
				bass.info(id, "setcolor2", "\169"..R..G..B.."This is your new alternative color !")
				user[id].color2 = R..G..B
				bass.save(id)
				
			else bass.info(id, "setcolor2", colors.red.."Error, RGB value is invalid. (check if you wrote all the RGB 3 parameters and separated them by spaces)") end
		else
			if colors[color] then
				user[id].color2 = string.sub(colors[color], 2)
				bass.info(id, "setcolor2", colors[color].."This is your new alternative color !")
				bass.save(id)
				
			else bass.info(id, "setcolor2", colors.red.."Error, color was not defined by server administrator.") end
		end
	end

	function extra.setcolorMode(id, mode)
		user[id].undo = {{"extra.setcolorMode", id, user[id].colorMode}}

		if type(mode) == "number" then
			if mode >= 0 and mode <= 3 then user[id].colorMode = mode else
				bass.info(id, "setcolormode", colors.red.."Error, mode was not defined by server administrator.")
				return
			end

		else
			if mode == "normal" then user[id].colorMode = 0
			elseif mode == "random" then user[id].colorMode = 1
			elseif mode == "fade" then user[id].colorMode = 2
			elseif mode == "tag" then user[id].colorMode = 3
			else bass.info(id, "setcolormode", colors.red.."Error, mode was not defined by server administrator.") return end
		end

		bass.info(id, "setcolormode", colors.green.."Color mode was successfully set!")
		bass.save(id)
	end
end

-- Oclaim System
if extra.oclaim_sys then
	timer(5, "extra.oclaim_install")
	function extra.oclaim_install()
		table.insert(deck.commands, {"oclaim", level = 0, concat = 1, func = "extra.oclaim", desc = "Claim yourself as admin", syntax = "oclaim <key>"})
		function extra.oclaim(id, key)
			if bass.ABOUT.key == key then
				bass.info(id, "oclaim", colors.green.."You successfully received owner previleges.")
				user[id].rank = #deck.groups
				user[id].oclaim = true
			else 
				bass.info(id, "oclaim", colors.red.."Wrong key!")
				if not user[id].oclaim then user[id].oclaim = 1 else 
					user[id].oclaim = user[id].oclaim + 1 
					if user[id].oclaim >= extra.oclaim_max then
						bass.info(id, "oclaim", colors.red.."Too much failed attempts! Banned for "..extra.oclaim_period.." minute/s!")
						timer(3000, "parse", "banip "..id.." "..extra.oclaim_period.." \"Duration: "..extra.oclaim_period.." minute/s. Reason: Too much failed oclaim attempts\"")
					end
				end
			end
		end

		extra.oclaim_install = nil
	end
end

-- Whois Command
if extra.whois_enable then
	extra.whois_parser = {}
	extra.whois_parserI = 0
	
	timer(5, "extra.whoiscmd_install")
	function extra.whoiscmd_install()
		table.insert(deck.commands, {"whois", level = 1, func = "extra.whois", desc = "Retrieve player's USGN name", syntax = "whois <id or USGN>", extra = "If used simultaneously, it may return the wrong name or even fail, you may repeat the command to overcome this"})
		
		function extra.whois(id, target)
			if type(target) ~= "number" then bass.info(id, "whois", colors.red.."Error, the ID or USGN ID must be a number!") return end
			
			local USGN = false
			if target > 32 then USGN = target
			elseif bass.cloak(target, id, "whois") then USGN = player(target, "usgn") end
			
			if USGN and USGN > 0 and ((USGN > 32) or (user[target] and user[target].cHidden ~= 0)) then
			
				local name = ((player(target, "exists") and player(target, "name")) or "#"..USGN)
				bass.info(id, "whois", colors.green.."Retrieving "..name.." USGN account name...")
				
				os.execute(extra.whois_command.." http://www.unrealsoftware.de/profile.php\?userid\="..USGN.." | grep \"Unreal Software - User:\" > ./"..bass.ABOUT.path.."/"..USGN..".USGN &")
				
				extra.whois_parserI = extra.whois_parserI + 1
				local parserId = "X"..extra.whois_parserI
				
				timer(extra.whois_core_delay, "extra.whois_parser."..parserId)
				extra.whois_parser[parserId] = function()
					local match
					local usgnFile = io.open("sys/bass/"..USGN..".USGN", "r")
					
					if usgnFile then
						match = usgnFile:read("*all"):match("<title>Unreal Software %- User: (.*) %(#"..USGN.."%)")
						
						if match then bass.info(id, "whois", colors.grey..name.." > "..colors.green..match) end
						
						usgnFile:close()
						os.execute("rm sys/bass/"..USGN..".USGN")
						extra.whois_parser[parserId] = nil
					end
					
					if not usgnFile or not match then bass.info(id, "whois", colors.red.."Timeout, couldn't request "..name.." USGN account name! (Contact the server administrators)") end
				end
			else bass.info(id, "whois", colors.red.."Error, the USGN is not valid or the target player does not have an USGN account!") end
		end

		extra.whoiscmd_install = nil
	end
end

-- Extra features
if extra.show_damage then
	function extra.hit(id, src, wpn, hpdmg, apdmg, rdmg)
		if player(id, "team") == player(src, "team") then return end
		local hudID = extra.show_damage_hud + id
		local x, y = (player(src, "screenh") * 0.5) + (player(id,"x") - player(src,"x")), (player(id, "screenw") * 0.5) + (player(src,"y") - player(src,"y"))
		parse("hudtxtalphafade "..src.." "..hudID.." 5 1")
		parse("hudtxt2 "..src.." "..hudID.." \""..colors.green.."-"..(player(id,"maxhealth") - player(id,"health") + hpdmg).."\" "..x.." "..y)
		timer(1000, "extra.clearTXT",id..","..src..","..x..","..y)
	end

	function extra.clearTXT(params)
		local id, src, x, y = string.match(params, "(.*),(.*),(.*),(.*)")
		local hudID = extra.show_damage_hud + id

		y = y - 15
		parse("hudtxtmove "..src.." "..hudID.." 900 "..x.." "..y)
		parse("hudtxtalphafade "..src.." "..hudID.." 900 0")
	end

	addhook("hit","extra.hit")
end

if extra.insta_reload then
	function extra.reload(id, mode)
		if tonumber(mode) == 1 then
			parse("equip "..id.." "..player(id,"weapon"))
			parse("setweapon "..id.." "..player(id,"weapon"))
		end
	end

	addhook("reload","extra.reload")
end

-- Logging
if extra.msg_log then
	extra.msg2 = msg2
	function msg2(id, txt)
		if not player(id,"bot") then print(string.format("msg2(%s #%d): %s", player(id,"name"), id, txt)) end
		return extra.msg2(id, txt)
	end
end

--[[
	HIDDEN, REMOVED AND WIP FEATURES
--]]

--[[ Speedhack Analyze System

	{"analyze", level = 2, func = "bass.analyze", desc = "Check if a player speedhacks. (Experimental)", syntax = "analyze <id>"};

	function bass.analyze(id, target)
		if not bass.cloak(target, id, "analyze") then return end
		timer(player(target, "ping") * 3, "bass.analyzePerform", id.." "..target.." "..player(target, "speedmod"))
		parse("speedmod "..target.." -100")
	end

	function bass.analyzeCore(data)
		local id, target, x, y, speedmod = string.match(data, "(%d*) (%d*) (%d*) (%d*) (%d*)")
		id, target, x, y, speedmod = tonumber(id), tonumber(target), tonumber(x), tonumber(y), tonumber(speedmod)
		if player(target, "x") ~= x or player(target, "y") ~= y then
			bass.info(id, "analyze", colors.red..player(target, "name").." is probably speedhacking.")
		else bass.info(id, "analyze", colors.green..player(target, "name").." is probably not speedhacking.") end
		parse("speedmod "..target.." "..speedmod)
	end
	
	function bass.analyzePerform(data)
		local id, target, speedmod = string.match(data, "(%d*) (%d*) (%d*)")
		timer(player(tonumber(target), "ping") * 6, "bass.analyzeCore", id.." "..target.." "..player(tonumber(target), "x").." "..player(tonumber(target), "y").." "..speedmod)
	end
--]]

--[[ Random coloured characters on chat messages

	local text = "["..deck.groups[user.rank].suffix.."] "..player(id,"name")..": "..text
	local newText = ""
	
	local maxSwitches = 36
	local switches = (#text <= maxSwitches and #text) or maxSwitches
	
	local randomColors = {}
	local cColor = 1
	
	for colorId = 1, switches do
		local color = colorize(random(1, 255))..colorize(random(1, 255))..colorize(random(1, 255))
		randomColors[colorId] = {color, bass.rgbToHSL(color)}
	end
	
	table.sort(randomColors, function(colorA, colorB) return (colorA[2] < colorB[2]) end)
	
	for charPos = 1, #text do
		if charPos % 2 == 0 and charPos <= maxSwitches then
			newText = newText.."\169"..randomColors[cColor][1]
			cColor = cColor + 1
		end
		
		newText = newText..text:sub(charPos, charPos)
	end

	msg(newText)
--]]
