--[[
	BASS DECK
	THIS IS WHERE ALL THE INFORMATION AND SUCH GOES IN
--]]

deck.groups = {
	[-1] = {level = -1, suffix = "Idiot"};
	[0] = {level = 0, suffix = "User"};
	[1] = {level = 1, suffix = "VIP"};
	[2] = {level = 2, suffix = "Supporter"};
	[3] = {level = 3, suffix = "Moderator"};
	[4] = {level = 4, suffix = "Owner"};
}

deck.commands = {
	preffix = "!";
	{"cmds", "help", level = 0, func = "bass.commands", desc = "Command list."};
	{"pm", level = 0, concat = 2, func = "bass.message", desc = "Send a private message to a specific player.", syntax = "pm <[id]> <text>", extra = "If you want to reply to the last player you/who pm'ed, don't specify the ID."};
	{"rs", "resetscore", level = 0, func = "bass.resetscore", desc = "Reset score", extra = "Resetting score various times may worse you server rank as only kills get deleted from it!"};
	{"o", level = 2, func = "bass.online", desc = "Get online STAFF list."};
	{"conceal", "cloak", level = 2, func = "bass.silence", desc = "Turn on / off cloak. (Information messages whenever you use a command)"};
	{"tag", "prefix", level = 1, func = "bass.tag", desc = "Turn on / off your chat tag."};
	{"setcolor", "chatcolor", level = 1, concat = 1, func = "bass.setcolor", desc = "Set chat color.", syntax = "setcolor <color name or RGB value>", extra = "If you want to use RGB value, separate it using spaces, (example !setcolor 255 0 25)"};
	{"palette", "colors", level = 1, func = "bass.palette", desc = "Color list."};
	{"usgn", level = 0, func = "bass.usgn", desc = "USGN IDs list."};
	{"hide", level = 2, func = "bass.hide", desc = "Hide your USGN ID from usgn list command. (toogle)"};
	{"register", level = 4, func = "bass.promote", desc = "Set a player rank.", syntax = "setrank <id or USGN ID> <level>", extra = "Levels go from -1 to "..#deck.groups};
	{"mc", level = 2, concat = 1, func = "bass.modchat", desc = "Chat on the private modchat."};
	{"rcon", level = 4, concat = 1, func = "parse", desc = "Execute a command (server side).", syntax = "rcon <command>"};
	{"map", "changemap", level = 3, concat = 1, func = "parse", params = "map", desc = "Change server map.", syntax = "map <map>"};
	{"up", level = 3, func = "parse", params = "map "..game("sv_map") , desc = "Hard restart."};
	{"rr", level = 3, concat = 1, func = "parse", params = "restartround", desc = "Restart round."};
	{"kick", level = 2, concat = 2, func = "bass.kick", desc = "Kick a player.", syntax = "kick <id> <[reason]>"};
	{"ban", level = 2, concat = 3, func = "bass.ban", desc = "Ban a player.", syntax = "ban <id> <[duration]> <[reason]>"};
	{"banip", level = 3, concat = 3, func = "bass.banip", desc = "Ban an IP.", syntax = "banip <id or IP> <[duration]> <[reason]>"};
	{"mute", level = 2, func = "bass.mute", desc = "Mute a player.", syntax = "mute <id> <[time]>", extra = "Time must be specified in minutes"};
	{"unmute", level = 2, func = "bass.unmute", desc = "Unmute a player.", syntax = "unmute <id>"};
	{"slap", level = 2, concat = 1, func = "parse", params = "slap", desc = "Slap a player.", syntax = "slap <id>"};
	{"shake", level = 2, concat = 1, func = "parse", params = "shake", desc = "Shake a player.", syntax = "shake <id> <power>"};
	{"freeze", level = 3, func = "bass.freeze", desc = "Freeze a player. (Keep him from moving)", syntax = "freeze <id>"};
	{"melt", "unfreeze", level = 3, func = "bass.melt", desc = "Unfreeze a player.", syntax = "melt <id>"};
	{"warp", level = 4, func = "bass.goto", desc = "Teleport to player.", syntax = "warp <id>"};
	{"push", level = 4, func = "bass.btm", desc = "Teleport player you.", syntax = "push <id>"};
	{"info", level = 2, func = "bass.get", desc = "Get player informations.", syntax = "info <id>"};
	{"l", level = 4, concat = 1, func = "bass.dolua", desc = "dostring the following script.", syntax = "l <script>"};
	{"event", level = 3, concat = 1, func = "bass.event", desc = "Perform an announcement.", syntax = "event <text>"};
	{"shuffle", level = 3, func = "bass.shuffle", desc = "Shuffle teams.", syntax = "shuffle <[balance]>", extra = "Type balance to balance the teams by the players score ratio (score / deaths)."};
	{"undo", level = 2, func = "bass.undo", desc = "Undo your last action (if possible).", extra = "This command will only keep the last action in the memory!"};
	{"wooble", "author", level = -1, func = "bass.wooble", desc = "Script information."};
}

colors = {
	["cyan"]			= "\169000255255";
	["light blue"]		= "\169210235255";
 	["blue"]			= "\169000000255";
 	["sea blue"]		= "\169000128128";
	["dark blue"]		= "\169000000128";
	["neutral blue"]	= "\169000155255";
	["yellow"]			= "\169255255000";
	["dc yellow"]		= "\169255220000";
	["black"]			= "\169000000000";
	["red"]				= "\169255000000";
	["dark red"]		= "\169128000000";
	["green"]			= "\169000255000";
	["light green"]		= "\169154255120";
	["camo green"]		= "\169136187060";
	["white"]			= "\169255255255";
	["light grey"]		= "\169192192192";
	["grey"]			= "\169128128128";
	["pink"]			= "\169255000255";
	["hot pink"]		= "\169255040120";
	["light pink"]		= "\169255130255";
	["purple"]			= "\169128000128";
	["dark purple"]		= "\169070000070";
	["light purple"]	= "\169130060130";
	["orange"]			= "\169255100000";
	["lilac"]			= "\169200160200";
	["brown"]			= "\169128050000";
}

deck.welcome = {
	colors.green.."Greetings "..colors["light green"].."<_n>"..colors.green..", _sv welcomes you!";
	colors.green.."Welcome to _sv "..colors["light green"].."<_n>"..colors.green.."!";
}
