--[[
	BASS SPEAKERS
	THIS IS WHERE THE FUNCTIONS THAT ARE GOING TO BE PERFORMED BY THE COMMANDS GO IN
--]]

function bass.wooble(id)
	msg2(id, colors.grey.."Bass Administrating Powertool")
	msg2(id, colors.grey.."Version "..colors["light grey"]..bass.ABOUT.code.." "..colors.grey.."v"..bass.ABOUT.version)
	msg2(id, colors.grey.."Last updated on "..bass.ABOUT.date)
	msg2(id, colors.grey.."Written by _Yank @ 94235")
	msg2(id, colors.grey.."(( BASS )) @C")
end

function bass.event(id, event)
	event = "Announcement: "..event

	local maxX = 854
	for _, id in pairs(player(0,"table")) do maxX = (player(id, "screenw") > maxX and player(id, "screenw")) or maxX end

	local sizex = maxX / 32
	local sizey = 18 / 32
	
	if not bass.eventBackground or bass.eventBackground == 0 then
		bass.eventBackground = image("gfx/block.bmp", maxX * 0.5, 35, 2)
		imagescale(bass.eventBackground, sizex, 0)
		tween_scale(bass.eventBackground, 600, sizex, sizey)
		imagecolor(bass.eventBackground, 0, 155, 0)
	else
		freetimer("bass.closeEvent", bass.eventBackground)
		freetimer("bass.closeEvent", "null")
		imagescale(bass.eventBackground, sizex, sizey)
	end

	bass.eventBackgroundWidth = sizex
	
	imagealpha(bass.eventBackground, 0.6)
	
	parse("hudtxt "..extra.server_promote_hud.." \""..colors.green..event.."\" 0 25")
	parse("hudtxtmove 0 "..extra.server_promote_hud.." 14000 "..(maxX + string.len(event)).." 25")
	parse("sv_sound yank/message.ogg")
	timer(14000, "bass.closeEvent", bass.eventBackground)
end

function bass.undo(id)
	local pi = user[id]
	if not pi.undo then bass.info(id, "undo", colors.red.."Last action not found.") else
		local func = pi.undo[1][1]
		local params = pi.undo[1]
		table.remove(params, 1)
		loadstring(func.."(...)")(unpack(params))

		if pi.undo[2] then bass.info(id, "undo", pi.undo[2]) end

		pi.undo = false
	end
end

function bass.resetscore(id)
	parse("setscore "..id.." 0")
	parse("setdeaths "..id.." 0")
	bass.info(id, "resetscore", colors.green.."Score successfully reseted!")
end

function bass.shuffle(id, balance)
	local sort
	local playlist = player(0, "team1")
	for _, current in ipairs(player(0, "team2")) do table.insert(playlist, current) end

	if balance then
		sort = function(a, b)
			local aScoreRatio = player(a, "score") / player(a, "deaths")
			local bScoreRatio = player(b, "score") / player(b, "deaths")
			return aScoreRatio < bScoreRatio
		end
	else sort = function() return math.random(1,2) == 1 end end
	table.sort(playlist, sort)

	for modifier, current in ipairs(playlist) do if modifier % 2 == 0 then parse("maket "..current) else parse("makect "..current) end end
	if not balance then msg(colors.green.."Teams have been shuffled.") else msg(colors.green.."Teams have been balanced by score ratio.") end
end

function bass.silence(id)
	user[id].cSilence = (user[id].cSilence ~= 0 and 0) or 1
	local pos = (user[id].cSilence == 1)
	bass.info(id, "conceal", ((pos and "") or colors.red).."Silent mode "..((pos and "enabled") or "disabled")..".")
	bass.save(id)
end

function bass.commands(id, page)
	local pi = user[id]
	if pi.rank < 0 then bass.info(id, "help", colors.red.."You are blacklisted, you can't use any commands!") return end

	local list = deck.commands
	local available = {}
	for _, command in ipairs(list) do if pi.rank >= command.level then table.insert(available, command) end end

	if type(page) == "number" or not page then
		if extra.menu_help then
			local page = page or 1
			local pages = math.ceil(#available / 6)
			if page < 1 then page = pages end
			if page > pages then page = 1 end

			local menuString = "Commands ("..page.."/"..pages..")"
			for i = 6 * page - 5, 6 * page do if available[i] then menuString = menuString..", "..list.preffix..available[i][1] else menuString = menuString.."," end end

			if page == pages then menuString = menuString..",,First page" else menuString = menuString..",,Next page" end
			if page == 1 then menuString = menuString..",Last page" else menuString = menuString..",Previous page" end
			menu(id, menuString)
		else
			bass.info(id, "help", colors.green.."Available command list:")
			for i = 1, #available do msg2(id, colors.white..available[i][1]..": "..colors.green..available[i].desc) end
			bass.info(id, "help", colors.green.."Type \""..list.preffix.."help <command>\" for command syntax and extra information!")
		end
		
	else
		local call = (page:find(deck.commands.preffix) and page:match(deck.commands.preffix.."(.*)")) or page
		
		for key, command in ipairs(deck.commands) do
			local found = false
			if #command > 1 then for currentCommand = 1, #command do if call == command[currentCommand] then found = true end end
			elseif call == command[1] then found = true end
			
			if found then
				msg2(id, colors.green.."Command: "..colors.grey..deck.commands.preffix..command[1]..colors.green)
				msg2(id, colors.green.."Description: "..command.desc)
				if command.syntax then msg2(id,colors.green.."Usage: "..deck.commands.preffix..command.syntax) end
				if command.extra then msg2(id,colors.grey.."Extra: "..command.extra) end
				return
			end
		end
			
		bass.info(id, "help", colors.red.."Error, command \""..call.."\" not found!")
	end
end

function bass.message(id, target, text)
	if target and type(target) == "string" then
		if user[id].cPm ~= 0 then
			text = target.." "..(text or "")
			target = user[id].cPm
		else bass.info(id, "pm", colors.red.."Error, can't find last PM'er.") end
	end

	if not bass.cloak(target, id, "pm", true) then return end

	user[target].cPm = id
	user[id].cPm = target

	if (text ~= "") then	
		bass.info(id, "PM", colors["light grey"].."<"..player(id, "name").." - "..player(target, "name").."> "..colors.grey..text)
		bass.info(target, "PM", bass.getName(id).." "..colors.grey..text) 
		parse("sv_sound2 "..target.." yank/message.ogg")
	else bass.info(id, "pm", colors.red.."Error, you must type something.") end
end

function bass.modchat(id, text)
	for _, current in ipairs(player(0, "table")) do
		if user[current].rank >= 2 then bass.info(current, "MC", bass.getName(id).." "..colors.grey..text) end
	end
end

function bass.usgn(id)
	for _, current in ipairs(player(0, "table")) do
		msg2(id, colors.grey..player(current, "name").." > "..colors.green..((user[current].cHidden <= 0 and player(current, "usgn")) or "0"))
	end
end

function bass.hide(id)
	user[id].cHidden = (user[id].cHidden ~= 0 and 0) or 1
	local pos = (user[id].cHidden == 1)
	bass.info(id, "hide", ((pos and "") or colors.red).."You are now "..((pos and "hidden from") or "visible to").." the !usgn command.")
end

function bass.online(id)
	for _, current in ipairs(player(0, "table")) do
		local rank = user[current].rank
		if rank > 0 then msg2(id, colors.grey..player(current, "name")..colors.green.." ["..(deck.groups[rank].suffix or "undefined rank").."]") end
	end
end

function bass.promote(id, target, level)
	if not level then bass.info(id, "register", colors.red.."Error, you must type a rank level!") return false
	elseif type(level) ~= "number" then bass.info(id, "register", colors.red.."Error, the rank level must be a number!") return false else
		if type(target) == "string" then
			if target:sub(1, 1) == "@" then
				target = target:match("@(%d*)")
			else bass.info(id, "register", colors.red.."Error, the target must be a player ID or an USGN ID started with a \"@\"!") return false end

			local previousData = io.open("sys/lua/users/"..target..".txt","r")
			local previousLevel = 0

			if previousData then
				previousLevel = tonumber(previousData:read("*all"):match("rank=(%d*)"))
				previousData:close()
				os.remove("sys/lua/users/"..target..".txt")
			end

			local pos = (level >= previousLevel)

			local file = io.open("sys/lua/users/"..target..".txt","w")
			file:write("rank="..level)
			file:close()

			bass.info(id, "register", ((pos and colors.green) or colors.red).."USGN ID#"..target.." successfully  "..((pos and "promoted") or "demoted").." to "..(deck.groups[level].suffix or "undefined rank").."!")
			user[id].undo = {{"promote", "@"..target, previousLevel}}
	
		elseif bass.cloak(target, id, "register") then
			local previousLevel = user[target].rank
			local pos = (level >= previousLevel)

			user[target].rank = level
			bass.info(id, "register", bass.getName(target, ((pos and colors.green) or colors.red)).." successfully "..((pos and "promoted") or "demoted").." to "..(deck.groups[level].suffix or "undefined rank").."!")
			bass.save(target)

			user[id].undo = {{"promote", target, previousLevel}}
		end
	end
end

function bass.kick(id, target, reason)
	if not bass.cloak(target, id, "kick") then return end
	if not reason then reason = "No reason specified." end
	reason = (reason and ((reason:find("\"") and reason:gsub("\"", "")) or reason)) or false
	bass.info(id, "kick", colors.green.."Name: "..colors.grey..player(target, "name")..colors.green..", USGN: "..colors.grey..player(target, "usgn")..colors.green..", IP: "..colors.grey..player(target, "ip"))
	parse("kick "..target.." \""..reason.."\"")
end

function bass.ban(id,target,duration,reason,...)
	if not bass.cloak(target, id, "ban") then return end
	if player(target, "usgn") == 0 then bass.info(id, "ban", colors.red.."Error, the specified user doesn't have an USGN account.") return false end

	if duration then
		if type(duration) == "string" then
			reason = duration..((reason or "").." "..table.concat(arg, " "))
			duration = 0
		elseif reason then reason = reason.." "..table.concat(arg, " ") end
	end

	duration = math.floor(duration or 0)
	reason = (reason and ((reason:find("\"") and reason:gsub("\"", "")) or reason)) or false
	
	local pi = user[id]

	if extra.tempban_sys then
		if pi.rank <= extra.tempban_rank then
			if duration < 1 then
				bass.info(id, "ban", colors.red.."Error, you can only temporary ban. (Specify how much minutes! max: "..extra.tempban_max..")")
				msg2(id, colors.grey.."Syntax: "..colors.red..deck.commands.preffix.."ban <id> <minutes> <[reason]>")
				return false

			elseif duration > extra.tempban_max then
				bass.info(id, "ban", colors.red.."Error, you can't temporary ban for more than "..extra.tempban_max.." minutes.")
				return false
			end
		end
	end

	duration = ((duration == 0 and "Perm.") or duration)
	bass.info(id, "banusgn", colors.green.."Name: "..colors.grey..player(target, "name")..colors.green..", USGN: "..colors.grey..player(target, "usgn")..colors.green..", IP: "..colors.grey..player(target, "ip")..colors.green..", Duration: "..colors.grey..duration)
	pi.undo = {{"parse", "unban "..player(target, "usgn")}, colors.green.."USGN ID "..target.." unbanned successfully!"}
	parse("banusgn "..target.." "..((type(duration) == "number" and duration) or 0).." \"Banned for "..duration.." min/s. Reason: "..(reason or "No reason specified.").."\"")
end

function bass.banip(id,target,duration,reason,...)
	if type(target) == "number" then
		if not bass.cloak(target, id, "banip") then return end
	end

	if duration then
		if type(duration) == "string" then
			reason = duration..((reason or "").." "..table.concat(arg, " "))
			duration = 0
		elseif reason then reason = reason.." "..table.concat(arg, " ") end
	end

	duration = math.floor(duration or 0)
	reason = (reason and ((reason:find("\"") and reason:gsub("\"", "")) or reason)) or false
	
	local pi = user[id]
	
	if extra.tempban_sys then
		if pi.rank <= extra.tempban_rank then
			if duration < 1 then
				bass.info(id, "ban", colors.red.."Error, you can only temporary ban. (Specify how much minutes! max: "..extra.tempban_max..")")
				msg2(id, colors.grey.."Syntax: "..colors.red..deck.commands.preffix.."banip <id or ip> <minutes> <[reason]>")
				return false
				
			elseif duration > extra.tempban_max then
				bass.info(id, "ban", colors.red.."Error, you can't temporary ban for more than "..extra.tempban_max.." minutes.")
				return false
			end
		end
	end

	duration = ((duration == 0 and "Perm.") or duration)
	bass.info(id, "banip", colors.green.."Name: "..colors.grey..player(target, "name")..colors.green..", USGN: "..colors.grey..player(target, "usgn")..colors.green..", IP: "..colors.grey..player(target, "ip")..colors.green..", Duration: "..colors.grey..duration)
	pi.undo = {{"parse", "unban "..player(target, "ip")}, colors.green.."IP "..target.." unbanned successfully!"}
	parse("banip "..target.." "..((type(duration) == "number" and duration) or 0).." \"Banned for "..duration.." min/s. Reason: "..(reason or "No reason specified.").."\"")
end

function bass.goto(id, target)
	if not bass.cloak(target, id, "warp") then return end
	parse("setpos "..id.." "..player(target,"x").." "..player(target,"y"))
end

function bass.btm(id,target)
	if not bass.cloak(target, id, "push") then return end
	parse("setpos "..target.." "..player(id,"x").." "..player(id,"y"))
end

function bass.mute(id, target, time)
	if not bass.cloak(target, id, "mute") then return end

	if not user[target].cMuted then
		user[target].cMuted = true

		if not time then
			msg2(target, colors.red.."You have been muted!")
			bass.info(id, "mute", colors.green.."User successfully muted.")
		elseif type(time) == "number" then 
			time = math.min(math.max(math.floor(time), 1), 60)
			timer(60000, "bass.muteCore", target, time)
			user[target].cMuted = time

			bass.info(id, "mute", colors.green.."User successfully muted for "..time.." minute/s.")
			msg2(target, colors.red.."You have been muted for "..time.." minute/s!")
		else bass.info(id, "mute", colors.red.."Error, time must be a number value.") return end

		user[id].undo = {{"bass.unmute", id, target}}

	else bass.info(id, "mute", colors.red.."Error, user already muted.") end
end

function bass.unmute(id, target)
	if not bass.cloak(target, id, "unmute") then return end

	if user[target].cMuted then
		if type(user[target].cMuted) == "number" then freetimer("bass.muteCore", target) end

		user[target].cMuted = false
		msg2(id, colors.green.."You have been unmuted!")

		bass.info(id, "unmute", colors.green.."User successfully unmuted.")
	else bass.info(id, "unmute", colors.red.."Error, user is not muted.") end
end

function bass.freeze(id, target)
	user[id].undo = {{"bass.melt", id, target}}

	if not bass.cloak(target, id, "freeze") then return end
	user[target].cSpeed = player(target, "speedmod")
	parse("speedmod "..target.." -100")
	bass.info(id, "unmute", colors.green.."User successfully freezed.")
end

function bass.melt(id, target)
	if not bass.cloak(target, id, "melt") then return end
	parse("speedmod "..target.." "..user[target].cSpeed)
	bass.info(id, "melt", colors.green.."User successfully melted.")
end

function bass.get(id,target)
	if not bass.cloak(target, id, "info") then return end
	msg2(id, colors.grey.."Name :"..colors.green..player(target,"name"))
	msg2(id, colors.grey.."IP :"..colors.green..player(target,"ip"))
	msg2(id, colors.grey.."Speedmod :"..colors.green..player(target,"speedmod"))
	msg2(id, colors.grey.."USGN ID :"..colors.green..player(target,"usgn"))
end

function bass.tag(id)
	user[id].tag = (user[id].tag == 1 and 0) or 1
	local pos = (user[id].tag == 1)
	bass.info(id, "tag", ((pos and colors.green) or colors.red).."Chat color "..((pos and "enabled") or "disabled").."!")
	bass.save(id)
end

function bass.setcolor(id, color)
	user[id].undo = {{"bass.setcolor", id, user[id].color:sub(1,3).." "..user[id].color:sub(4,6).." "..user[id].color:sub(7,9)}}

	if string.find(color, "%d") then
		local R, G, B = string.match(color, "(%d*) (%d*) (%d*)")
		if R and G and B then
			R, G, B = bass.colorize(R), bass.colorize(G), bass.colorize(B)
			bass.info(id, "setcolor", "\169"..R..G..B.."This is your new color!")
			user[id].color = R..G..B
			bass.save(id)
		else bass.info(id, "setcolor", colors.red.."Error, RGB value is invalid. (check if you wrote all the RGB 3 parameters and separated them by spaces)") end
	else
		if colors[color] then
			user[id].color = string.sub(colors[color], 2)
			bass.info(id, "setcolor", colors[color].."This is your new color!")
			bass.save(id)
		else bass.info(id, "setcolor", colors.red.."Error, color was not defined by server administrator.") end
	end
end

function bass.palette(id)
	local availableColors = {}
	
	for color, value in pairs(colors) do table.insert(availableColors, {name = color, HSL = bass.rgbToHSL(value:sub(2))}) end
	table.sort(availableColors, function(colorA, colorB) return (colorA.HSL < colorB.HSL) end)
	
	for _, color in pairs(availableColors) do
		msg2(id, colors[color.name]..deck.commands.preffix.."palette: "..color.name)
	end
end

function bass.dolua(id, script)
	assert(pcall(loadstring(script)))
end
